/*
 * Created on 27 aot 2009
 */
package deltadore.x2d.example;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * @author y-lebret
 */
public class Console extends JFrame implements KeyListener {
	private JTextArea _textArea;
	private SignalHandle _keySignal;
	private SignalHandle _returnSignal;
	private char _typedKey;
	private String _typedText;
	private boolean _editMode = false;

	public Console(String title) {
		super(title);
        setBounds(0, 0, 640, 480);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        _textArea = new JTextArea();
        _textArea.disable();
        _textArea.setBackground(Color.BLACK);
        _textArea.setForeground(Color.LIGHT_GRAY);
        _textArea.setFont(new Font("courier", Font.BOLD, 15));
        getContentPane().add(new JScrollPane(_textArea));        
        _keySignal = new SignalHandle();
        _returnSignal = new SignalHandle();
        addKeyListener(this);
        setVisible(true);
	}
	
	public void keyPressed(KeyEvent evt) {}
	public void keyReleased(KeyEvent evt) {}  
	public void keyTyped(KeyEvent evt) {
		char key = evt.getKeyChar();
		if (_editMode) {
			if (key == '\n') {
				_editMode = false;
				write("\n");
				_returnSignal.setSignal();
			}
			else if (key == 8) {
				if (_typedText.length() > 0) {
					_typedText = _typedText.substring(0, _typedText.length() - 1);
					String text = _textArea.getText();
					_textArea.setText(text.substring(0, text.length() - 1));
				}
			}
			else {
				_typedText += String.valueOf(key);
				write(String.valueOf(key));
			}
		}
		else {
			_typedKey = key;
			_keySignal.setSignal();
		}
	}

	public void write(String s) {
		_textArea.append(s);
		try {
			_textArea.scrollRectToVisible(_textArea.modelToView(_textArea.getDocument().getLength()));
		}
		catch (javax.swing.text.BadLocationException err) {}
	}

	public void writeLine() {
		_textArea.append("\n");
		try {
			_textArea.scrollRectToVisible(_textArea.modelToView(_textArea.getDocument().getLength()));
		}
		catch (javax.swing.text.BadLocationException err) {}
	}

	public void writeLine(String s) {
		_textArea.append(s + "\n");
		try {
			_textArea.scrollRectToVisible(_textArea.modelToView(_textArea.getDocument().getLength()));
		}
		catch (javax.swing.text.BadLocationException err) {}
	}
	
	public char readKey() {
		_keySignal.waitSignal();
		return _typedKey;
	}
	
	public String readLine() {
		_typedText = "";
		_editMode = true;
		_returnSignal.waitSignal();
		return _typedText;
	}
}
